/*****************************************************************
|
|      Xaudio Platform Configuration Definitions
|
|
 ****************************************************************/

#ifndef __CONFIG_H__ 
#define __CONFIG_H__

/* default values, can be overriden for specific platforms */
#define XA_HAS_MALLOC
#define XA_HAS_CALLOC
#define XA_HAS_FREE
#define XA_HAS_MEMSET
#define XA_HAS_MEMCPY
#define XA_HAS_STRLEN
#define XA_HAS_STRDUP
#define XA_HAS_STRCPY
#define XA_HAS_STRCMP
#define XA_HAS_STRNCMP
#define XA_HAS_STRCASECMP
#define XA_HAS_STRNCASECMP
#define XA_HAS_STRCPY
#define XA_HAS_STRNCPY
#define XA_HAS_STRCHR
#define XA_HAS_STRTOUL
#define XA_HAS_CTYPE
#define XA_HAS_SPRINTF
#define XA_HAS_SSCANF
#undef  XA_HAS_CLOSEAPPS

#define XA_HAS_STDLIB_H
#define XA_HAS_STRING_H
#define XA_HAS_STDIO_H
#define XA_HAS_SETJMP_H


#ifndef NULL
#define NULL (void *)0
#endif

/* for the sun C++ compiler, bool is not defined */
#ifdef __SUNPRO_CC
#ifdef __cplusplus
typedef enum { false=0, true=1 } bool;
#endif /* __cplusplus */
#endif /* __SUNPRO_CC */
#if defined(WIN32)
#ifndef UNDER_CE
#define strncasecmp _strnicmp
#endif
#if _MSC_VER <= 1100
#define bool  int
#define true  1
#define false 0
#endif /* _MSC_VER <= 1000 */
#endif /* defined(WIN32) */

/* windows CE */
#ifdef UNDER_CE
#undef XA_HAS_STDIO_H
#undef XA_HAS_STRDUP

#if UNDER_CE < 212
#undef XA_HAS_CTYPE
#undef XA_HAS_CALLOC
#undef XA_HAS_STRTOUL
#else
#include <aygshell.h>
#define XA_HAS_CLOSEAPPS
#define memory_closeapps SHCloseApps
#define memory_alloc0	malloc
#endif

#undef XA_HAS_SPRINTF
#undef XA_HAS_STRCASECMP
#undef XA_HAS_STRNCASECMP
#endif /* _UNDER_CE */

/* Metrowerks / MacOS */
#ifdef __MWERKS__
#undef XA_HAS_STRNCASECMP
#undef XA_HAS_STRDUP
#define strdup string_duplicate
#endif /* __MWERKS__ */

/* QNX */
#ifdef __QNX__
#define HAVE_SYS_SELECT
#endif

/* Nintendo 64 */
#ifdef __n64__
#undef XA_HAS_STDIO_H
#undef XA_HAS_STRING_H
#undef XA_HAS_STDLIB_H
#undef XA_HAS_SETJMP_H
#undef XA_HAS_CALLOC
#undef XA_HAS_MEMSET
#undef XA_HAS_MEMCPY
#undef XA_HAS_STRLEN
#undef XA_HAS_STRDUP
#undef XA_HAS_STRCPY
#undef XA_HAS_STRCMP
#undef XA_HAS_STRNCMP
#undef XA_HAS_STRCASECMP
#undef XA_HAS_STRNCASECMP
#undef XA_HAS_STRCPY
#undef XA_HAS_STRNCPY
#undef XA_HAS_STRCHR
#undef XA_HAS_SSCANF
#endif /* __n64__ */

/* Cyrus Logics Eval Board with ARMCC */
#ifdef __ARMCC_VERSION
#undef XA_HAS_STRDUP
#endif /* __ARMCC_VERSION */

/* TI 54x DSP */
#ifdef _TMS320C5XX
#undef XA_HAS_STRDUP
#undef XA_HAS_STRCASECMP
#undef XA_HAS_STRNCASECMP
#endif /* _TMS320C5XX */

/* Motorola ColdFire with Diab DATA compiler */
#if defined(__DCC__) && defined(__coldfire)
#undef XA_HAS_STRNCASECMP
#endif /* defined(__DCC__) && defined(__coldfire) */

/* include standard C runtime headers */
#ifdef XA_HAS_STDLIB_H
#include <stdlib.h>
#endif

#ifdef XA_HAS_STRING_H
#include <string.h>
#endif

#ifdef XA_HAS_STDIO_H
#include <stdio.h>
#endif

#ifdef XA_HAS_SETJMP_H
#include <setjmp.h>
#endif

#endif /* __CONFIG_H__ */







