// PocketTV
//

#ifndef STRICT
#define STRICT
#endif

#include "stdafx.h"
#include "pockettv.hpp"
#include "registry.h"

#define CHROMA_SHIFT_MIN		(-16)
#define CHROMA_SHIFT_MAX		16

/* values for MTVP_COMMAND_VIDEO_CHROMA_SATURATION or Chroma_correct */
#if defined(POCKET_PC) && defined(ARM)
#define CHROMA_SATURATION_DEFAULT	140
#define GAMMA_DEFAULT	1.5
#define CHROMA_SHIFT_CR_DEFAULT	3
#define CHROMA_SHIFT_CB_DEFAULT	MTVP_CHROMA_SHIFT_CB_NORMAL
#else
#define CHROMA_SATURATION_DEFAULT	MTVP_CHROMA_SATURATION_NORMAL
#define GAMMA_DEFAULT	MTVP_GAMMA_NORMAL
#define CHROMA_SHIFT_CR_DEFAULT	MTVP_CHROMA_SHIFT_CR_NORMAL
#define CHROMA_SHIFT_CB_DEFAULT	MTVP_CHROMA_SHIFT_CB_NORMAL
#endif


/*----------------------------------------------------------------------
| DisplaySliderProc
+---------------------------------------------------------------------*/
LRESULT 
PocketTV::DisplaySliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	if (!m_DisplaySlider) {
        return CallWindowProc((WNDPROC)m_DisplaySliderParentOriginalProc, 
                              window, message, wparam, lparam);
	}
    switch (message) {
      case WM_HSCROLL:
      case WM_VSCROLL:
        switch(LOWORD(wparam)) {
          case SB_LINELEFT:
          case SB_LINERIGHT:
          case SB_PAGELEFT:
          case SB_PAGERIGHT:
//			  if (!m_SettingVolume) {
//				  m_SettingVolume = true;
//			  }
 //           MySetVolume(SendMessage(m_VolumeSlider,
//                                     TBM_GETPOS, 0, 0));
			SetDisplaySetting(SendMessage(m_DisplaySlider, TBM_GETPOS, 0, 0));
            break;

          case SB_THUMBPOSITION: 
          case SB_ENDSCROLL:
 //           MySetVolume(SendMessage(m_VolumeSlider,
//                                     TBM_GETPOS, 0, 0));
//			  if (m_SettingVolume) {
//				  m_SettingVolume = false;
//			  }
			SetDisplaySetting(SendMessage(m_DisplaySlider, TBM_GETPOS, 0, 0));
            break;
          case SB_THUMBTRACK:
//			  if (!m_SettingVolume) {
//				  m_SettingVolume = true;
//			  }
//            MySetVolume(HIWORD(wparam));
			SetDisplaySetting(SendMessage(m_DisplaySlider, TBM_GETPOS, 0, 0));
			break;
        }
        break;

      default:
        return CallWindowProc((WNDPROC)m_DisplaySliderParentOriginalProc, 
                              window, message, wparam, lparam);
    }

    return 0;
}

/*----------------------------------------------------------------------
|       RealDisplaySliderProc
+---------------------------------------------------------------------*/
LRESULT CALLBACK 
RealDisplaySliderProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	PocketTV *player = Player;

	return player->DisplaySliderProc(window, message, wparam, lparam);
}

/*----------------------------------------------------------------------
| InitDisplaySettingInfo
+---------------------------------------------------------------------*/
void 
PocketTV::InitDisplaySettingInfo()
{	
	DWORD value;
	int		i;

#if 0
	m_DisplaySettingInfo[DISPLAY_SETTING_BRIGHTNESS].caption = TEXT("Brightness");
	m_DisplaySettingInfo[DISPLAY_SETTING_BRIGHTNESS].registry = TEXT("Brightness");
	m_DisplaySettingInfo[DISPLAY_SETTING_BRIGHTNESS].default_value = 100 - (DWORD)((MTVP_LUMA_SHIFT_NORMAL - MTVP_LUMA_SHIFT_MIN) * 100 ) / (MTVP_LUMA_SHIFT_MAX - MTVP_LUMA_SHIFT_MIN);
	m_DisplaySettingInfo[DISPLAY_SETTING_CONTRAST].caption = TEXT("Contrast");
	m_DisplaySettingInfo[DISPLAY_SETTING_CONTRAST].registry = TEXT("Contrast");
	m_DisplaySettingInfo[DISPLAY_SETTING_CONTRAST].default_value = (DWORD)((MTVP_LUMA_FLOOR_NORMAL - MTVP_LUMA_FLOOR_MIN) * 100 ) / (MTVP_LUMA_FLOOR_MAX - MTVP_LUMA_FLOOR_MIN);
#endif // 0
	m_DisplaySettingInfo[DISPLAY_SETTING_GAMMA].caption = TEXT("Gamma");
	m_DisplaySettingInfo[DISPLAY_SETTING_GAMMA].registry = TEXT("Gamma");
	m_DisplaySettingInfo[DISPLAY_SETTING_GAMMA].min = 0;
	m_DisplaySettingInfo[DISPLAY_SETTING_GAMMA].max = 100;
	m_DisplaySettingInfo[DISPLAY_SETTING_GAMMA].normal_value = 100 - (DWORD)(((MTVP_GAMMA_NORMAL - MTVP_GAMMA_MIN) * 100 ) / (MTVP_GAMMA_MAX - MTVP_GAMMA_MIN));
	m_DisplaySettingInfo[DISPLAY_SETTING_GAMMA].default_value = 100 - (DWORD)(((GAMMA_DEFAULT - MTVP_GAMMA_MIN) * 100 ) / (MTVP_GAMMA_MAX - MTVP_GAMMA_MIN));

	m_DisplaySettingInfo[DISPLAY_SETTING_CHROMA_SATURATION].caption = TEXT("Saturation");
	m_DisplaySettingInfo[DISPLAY_SETTING_CHROMA_SATURATION].registry = TEXT("Saturation");
	m_DisplaySettingInfo[DISPLAY_SETTING_CHROMA_SATURATION].min = MTVP_CHROMA_SATURATION_MIN;
	m_DisplaySettingInfo[DISPLAY_SETTING_CHROMA_SATURATION].max = MTVP_CHROMA_SATURATION_MAX;
	m_DisplaySettingInfo[DISPLAY_SETTING_CHROMA_SATURATION].normal_value = MTVP_CHROMA_SATURATION_MAX - MTVP_CHROMA_SATURATION_NORMAL;
	m_DisplaySettingInfo[DISPLAY_SETTING_CHROMA_SATURATION].default_value = MTVP_CHROMA_SATURATION_MAX - CHROMA_SATURATION_DEFAULT;

	m_DisplaySettingInfo[DISPLAY_SETTING_GREEN_RED].caption = TEXT("Green && Red");
	m_DisplaySettingInfo[DISPLAY_SETTING_GREEN_RED].registry = TEXT("GreenRed");
	m_DisplaySettingInfo[DISPLAY_SETTING_GREEN_RED].min = -16;
	m_DisplaySettingInfo[DISPLAY_SETTING_GREEN_RED].max = 16;
	m_DisplaySettingInfo[DISPLAY_SETTING_GREEN_RED].normal_value = - MTVP_CHROMA_SHIFT_CR_NORMAL;
	m_DisplaySettingInfo[DISPLAY_SETTING_GREEN_RED].default_value = - CHROMA_SHIFT_CR_DEFAULT;

	m_DisplaySettingInfo[DISPLAY_SETTING_YELLOW_BLUE].caption = TEXT("Yellow && Blue");
	m_DisplaySettingInfo[DISPLAY_SETTING_YELLOW_BLUE].registry = TEXT("YellowBlue");
	m_DisplaySettingInfo[DISPLAY_SETTING_YELLOW_BLUE].min = -16;
	m_DisplaySettingInfo[DISPLAY_SETTING_YELLOW_BLUE].max = 16;
	m_DisplaySettingInfo[DISPLAY_SETTING_YELLOW_BLUE].normal_value = - MTVP_CHROMA_SHIFT_CB_NORMAL;
	m_DisplaySettingInfo[DISPLAY_SETTING_YELLOW_BLUE].default_value = - CHROMA_SHIFT_CB_DEFAULT;

	for (i = 0; i < DISPLAY_SETTING_COUNT; i++) {
		if (GetRegistryValueDWORD(m_DisplaySettingInfo[i].registry, &value) == ERROR_SUCCESS) {
			m_DisplaySettingInfo[i].value = (int)value;
		} else {
			m_DisplaySettingInfo[i].value = m_DisplaySettingInfo[i].default_value;
		}
		SetDisplaySetting0(i, m_DisplaySettingInfo[i].value);
	}
}

/*----------------------------------------------------------------------
| SetDefaultDisplaySettings
+---------------------------------------------------------------------*/
void 
PocketTV::SetDefaultDisplaySettings()
{
	int		i;

	for (i = 0; i < DISPLAY_SETTING_COUNT; i++) {
		m_DisplaySettingInfo[i].value = m_DisplaySettingInfo[i].default_value;
		SetDisplaySetting0(i, m_DisplaySettingInfo[i].value);
	}
	ShowDisplaySetting();
}

/*----------------------------------------------------------------------
| SetNormalDisplaySettings
+---------------------------------------------------------------------*/
void 
PocketTV::SetNormalDisplaySettings()
{	
	int		i;

	for (i = 0; i < DISPLAY_SETTING_COUNT; i++) {
		m_DisplaySettingInfo[i].value = m_DisplaySettingInfo[i].normal_value;
		SetDisplaySetting0(i, m_DisplaySettingInfo[i].value);
	}
	ShowDisplaySetting();
}

/*----------------------------------------------------------------------
| ShowDisplaySetting
+---------------------------------------------------------------------*/
void 
PocketTV::ShowDisplaySetting()
{
	HWND hWnd = GetDlgItem(m_DisplayDialog, IDC_DISPLAY_CAPTION);
	
	SetWindowText(hWnd, m_DisplaySettingInfo[m_DisplaySetting].caption);
	SendMessage(m_DisplaySlider, TBM_SETRANGEMIN, FALSE, m_DisplaySettingInfo[m_DisplaySetting].min);
	SendMessage(m_DisplaySlider, TBM_SETRANGEMAX, FALSE, m_DisplaySettingInfo[m_DisplaySetting].max);
	SendMessage(m_DisplaySlider, TBM_SETPOS, TRUE, m_DisplaySettingInfo[m_DisplaySetting].value);
	SendMessage(m_DisplaySlider, TBM_SETTICFREQ, (m_DisplaySettingInfo[m_DisplaySetting].max - m_DisplaySettingInfo[m_DisplaySetting].min) / 2, 0);

//	hWnd = GetDlgItem(m_DisplayDialog, IDC_DISPLAY_NORMAL);
//
//	if (m_DisplaySettingInfo[m_DisplaySetting].default_value != m_DisplaySettingInfo[m_DisplaySetting].normal_value) {
//		ShowWindow(hWnd, SW_SHOW);
//	} else {
//		ShowWindow(hWnd, SW_HIDE);
//	}
}

/*----------------------------------------------------------------------
| SetDisplaySetting0
+---------------------------------------------------------------------*/
void 
PocketTV::SetDisplaySetting0(int i, int pos)
{
	SetRegistryValueDWORD(m_DisplaySettingInfo[i].registry, pos);

	switch (i) {
#if 0
	case DISPLAY_SETTING_BRIGHTNESS:
		{
			double x = MTVP_LUMA_SHIFT_MIN + (MTVP_LUMA_SHIFT_MAX - MTVP_LUMA_SHIFT_MIN) * (100 - pos) * 0.01;
			MtvpSetLumaShift(x);
		}
		break;
	case DISPLAY_SETTING_CONTRAST:
		{
			double x = MTVP_LUMA_FLOOR_MIN + (MTVP_LUMA_FLOOR_MAX - MTVP_LUMA_FLOOR_MIN) * pos * 0.01;
			MtvpSetLumaFloor(x);
		}
		break;
#endif // 0
	case DISPLAY_SETTING_GAMMA:
		{
			double x = MTVP_GAMMA_MIN + (MTVP_GAMMA_MAX - MTVP_GAMMA_MIN) * (100 - pos) * 0.01;
			MtvpSetGammaCorrection(x);
		}
		break;
	case DISPLAY_SETTING_CHROMA_SATURATION:
		{
			int x = MTVP_CHROMA_SATURATION_MAX - pos;
			MtvpSetChromaSaturation(x);
		}
		break;
	case DISPLAY_SETTING_GREEN_RED:
		{
			int x = (int)(- pos);
			MtvpSetChromaShiftCR(x);
		}
		break;
	case DISPLAY_SETTING_YELLOW_BLUE:
		{
			int x = (int)(- pos);
			MtvpSetChromaShiftCB(x);
		}
		break;
	}
}

/*----------------------------------------------------------------------
| SetDisplaySetting
+---------------------------------------------------------------------*/
void 
PocketTV::SetDisplaySetting(int pos)
{
	m_DisplaySettingInfo[m_DisplaySetting].value = pos;


	if (m_PendingDisplaySlider || m_PendingDisplaySliderPos >= 0) {
		m_PendingDisplaySliderPos = pos;
		return;
	}
	m_PendingDisplaySlider = true;

	MtvpSetSyncMode(MTVP_SYNC_MODE_ASYNC_WITH_ACK);

	SetDisplaySetting0(m_DisplaySetting, pos);
}

/*----------------------------------------------------------------------
| DisplayDialogProc
+---------------------------------------------------------------------*/
BOOL 
PocketTV::DisplayDialogProc(
	HWND hDlg, 
	UINT uMsg, 
	WPARAM wParam, 
	LPARAM lParam )
{
	BOOL	lResult = TRUE;
  
	switch(uMsg) {

	case WM_COMMAND: {
		int wID = LOWORD(wParam);
		int wNotifyCode = HIWORD(wParam);

		if (wNotifyCode != BN_CLICKED) {
			return TRUE;
		}

		switch (wID) {
			case IDOK:
				HideDisplayDialog();
				break;
//			case IDCANCEL:
//				HideDisplayDialog();
//				break;
			case IDC_DISPLAY_NEXT:
				m_DisplaySetting++;
				if (m_DisplaySetting == DISPLAY_SETTING_COUNT) {
					m_DisplaySetting = 0;
				}
				ShowDisplaySetting();
				break;
			case IDC_DISPLAY_RESET:
				SendMessage(m_DisplaySlider, TBM_SETPOS, TRUE, m_DisplaySettingInfo[m_DisplaySetting].default_value);
				SetDisplaySetting(m_DisplaySettingInfo[m_DisplaySetting].default_value);
				break;
			case IDC_DISPLAY_NORMAL:
				SendMessage(m_DisplaySlider, TBM_SETPOS, TRUE, m_DisplaySettingInfo[m_DisplaySetting].normal_value);
				SetDisplaySetting(m_DisplaySettingInfo[m_DisplaySetting].normal_value);
				break;
			case IDC_DISPLAY_PREVIOUS:
				if (m_DisplaySetting == 0) {
					m_DisplaySetting = DISPLAY_SETTING_COUNT - 1;
				}
				m_DisplaySetting--;
				ShowDisplaySetting();
				break;
		}
		}
		return TRUE;

	case WM_ACTIVATE:
      return TRUE;
      
    case WM_INITDIALOG:
		return TRUE;
      
    default:
      return FALSE;
      break;
	}
}

/*----------------------------------------------------------------------
|       RealDisplayDialogProc
+---------------------------------------------------------------------*/
BOOL CALLBACK 
RealDisplayDialogProc(HWND window, UINT message, WPARAM wparam, LPARAM lparam)
{
	PocketTV *player = Player;

	return player->DisplayDialogProc(window, message, wparam, lparam);
}


/*--------------------------------------------------------------------------+
| CreateDisplayDialog
+--------------------------------------------------------------------------*/
int
PocketTV::CreateDisplayDialog()
{
	int status;

	/////////////////////////////////////////////////////////////////////////////
	// create the display modeless dialog
	InitDisplaySettingInfo();

	m_DisplayDialog = CreateDialog(m_Instance, (LPCTSTR)IDD_DISPLAY, m_Window, RealDisplayDialogProc);
	if (!m_DisplayDialog) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create display dialog (error %d)"), status);
		return status ? status : -1;
	}
	{
		RECT window_rect;
		RECT dialog_rect;
		RECT slider_rect;
		GetWindowRect(m_Window, &window_rect);
		GetWindowRect(m_DisplayDialog, &dialog_rect);
		GetWindowRect(m_SeekSlider, &slider_rect);

		status = SetWindowPos(m_DisplayDialog,
							(HWND)0,
//							window_rect.right - window_rect.left - (dialog_rect.right - dialog_rect.left),
							0,
							(window_rect.bottom - window_rect.top)
								- (slider_rect.bottom - slider_rect.top)
								- (dialog_rect.bottom - dialog_rect.top),
							window_rect.right - window_rect.left,
							dialog_rect.bottom - dialog_rect.top,
							/*SWP_NOSIZE|*/SWP_NOZORDER);

		GetWindowRect(m_DisplayDialog, &dialog_rect);
		m_DisplayDialogTop = dialog_rect.top - window_rect.top;
	}

#ifndef ARM
	ShowWindow(GetDlgItem(m_DisplayDialog, IDC_DISPLAY_NORMAL), SW_HIDE);
#endif

    // create the display slider
    m_DisplaySlider = CreateWindow( 
//        TRACKBAR_CLASS, 
        m_TrackbarClass, 
        NULL,
		WS_CHILD|WS_VISIBLE|TBS_AUTOTICKS | TBS_VERT | TBS_ENABLESELRANGE | TBS_FIXEDLENGTH,
        10,
        0,
        28,
		65,
        m_DisplayDialog,
        NULL,
        m_Instance,
        NULL);

	if (!m_DisplaySlider) {
		status = GetLastError();
		ErrorBox(m_Window, IDS_WINDOW_CAPTION_ERROR, TEXT("Cannot create display slider (error %d)"), status);
		return status ? status : -1;
	}

	SendMessage(m_DisplaySlider, TBM_SETRANGEMAX, TRUE, 100);
	SendMessage(m_DisplaySlider, TBM_SETTHUMBLENGTH, 20, 0);
//	SendMessage(m_VolumeSlider, TBM_SETSEL, TRUE, MAKELPARAM(0, VOLUME_SLIDER_MAX));

    m_DisplaySliderParentOriginalProc = 
            (WNDPROC)GetWindowLong(m_DisplayDialog, GWL_WNDPROC);
    SetWindowLong(m_DisplayDialog, GWL_WNDPROC, (LONG)RealDisplaySliderProc);

	ShowDisplaySetting();
//	ShowDisplayDialog();
	return 0;
}

/*--------------------------------------------------------------------------+
| HideDisplayDialog
+--------------------------------------------------------------------------*/
void
PocketTV::HideDisplayDialog()
{
	if (m_DisplayDialogVisible) {
		ShowWindow(m_DisplayDialog, SW_HIDE);
		m_DisplayDialogVisible = false;

		UpdateVideoTargetRect();
	}
}

/*--------------------------------------------------------------------------+
| ShowDisplayDialog
+--------------------------------------------------------------------------*/
void
PocketTV::ShowDisplayDialog()
{
	if (!m_DisplayDialogVisible) {

		HideVolumeDialog();

		ShowWindow(m_DisplayDialog, SW_SHOW);
		SetForegroundWindow(m_DisplayDialog);
		int ret = SetWindowPos(m_DisplayDialog, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE|SWP_NOOWNERZORDER|SWP_NOSIZE|SWP_SHOWWINDOW);
		m_DisplayDialogVisible = true;

		UpdateVideoTargetRect();
	}
}

