/*****************************************************************
|
|      Xaudio Player for Windows CE
|      File Routines      
|
|      (c) 1996-1998 MpegTV, LLC
|      Author: Gilles Boccon-Gibod (gilles@mpegtv.com)
|
 ****************************************************************/

/*----------------------------------------------------------------------
|       includes
+---------------------------------------------------------------------*/
#ifndef STRICT
#define STRICT
#endif

#include "stdafx.h"

#include <commdlg.h>
#include <tchar.h>
#include <winnls.h>

//#include "xaplayer.h"
//#include "control.h"
#include "files.h"
#include "mtvp/ceutils.h"

/*----------------------------------------------------------------------
|       ChooseOpenFile
+---------------------------------------------------------------------*/
int
ChooseOpenFile(HWND parent,
			   TCHAR *buffer,
			   unsigned int size, 
//               FileChooserType type,
			   const TCHAR *caption,
			   const TCHAR *filter,
			   const TCHAR *default_extension)
{
	OPENFILENAME ofn = {0};
	
	ofn.lStructSize	= sizeof(ofn);
	ofn.hwndOwner   = parent;
    ofn.lpstrFile   = buffer;
    ofn.nMaxFile    = size;	
    ofn.lpstrTitle  = caption;
    ofn.Flags       = OFN_EXPLORER | OFN_PATHMUSTEXIST;
    ofn.lpstrFilter = filter;
    ofn.lpstrDefExt = default_extension;

    return GetOpenFileName(&ofn);
}