/*****************************************************************
|
|      Xaudio Player for Windows CE
|      File Routines      
|
|      (c) 1996-1998 MpegTV, LLC
|      Author: Gilles Boccon-Gibod (gilles@mpegtv.com)
|
 ****************************************************************/

/*----------------------------------------------------------------------
|       includes
+---------------------------------------------------------------------*/
#ifndef STRICT
#define STRICT
#endif

#include "stdafx.h"

#include <commdlg.h>
#include <tchar.h>
#include <winnls.h>

//#include "xaplayer.h"
//#include "control.h"
#include "files.h"
//#include "mtvp/ceutils.h"

/*----------------------------------------------------------------------
|       ChooseOpenFile
+---------------------------------------------------------------------*/
const TCHAR FileChooserMpegFiler[] = 
//    TEXT("MPEG movies (*.mpg)\0*.mpg\0All (*.*)\0*.*\0\0");	
    TEXT("MPEG movies (*.mpg;*.mpeg)\0*.mpg:*.mpeg\0All (*.*)\0*.*\0\0");	
//    TEXT("MPEG movies (*.mpg)\0*.mpg\0MPEG movies (*.mpeg)\0*.mpeg\0All (*.*)\0*.*\0\0");	
const TCHAR FileChooserMpegDefExt[] = TEXT("mpg");

#if 0
const TCHAR FileChooserPlayListFilter[] = 
    TEXT("PlayLists (*.pls)\0*.pls\0All (*.*)\0*.*\0\0");	
const TCHAR FileChooserPlayListDefExt[] = TEXT("pls");
#endif // 0

/*----------------------------------------------------------------------
|       ChooseOpenFile
+---------------------------------------------------------------------*/
int
ChooseOpenFile(HWND parent, TCHAR *buffer, unsigned int size, 
               FileChooserType type, const TCHAR *caption)
{
	TCHAR        file[MAX_PATH] = TEXT("");
	OPENFILENAME ofn;
	
	memset(&(ofn), 0, sizeof(ofn));
	ofn.lStructSize	= sizeof(ofn);
	ofn.hwndOwner   = parent;
    ofn.lpstrFile   = buffer;
    ofn.nMaxFile    = size;	
    ofn.lpstrTitle  = caption;
    ofn.Flags       = OFN_EXPLORER | OFN_PATHMUSTEXIST;
    switch (type) {
      case FILE_CHOOSER_TYPE_MPEG_VIDEO:
        ofn.lpstrFilter = FileChooserMpegFiler;
        ofn.lpstrDefExt = FileChooserMpegDefExt;
        break;
#if 0
      case FILE_CHOOSER_TYPE_PLAYLIST:
        ofn.lpstrFilter = FileChooserPlayListFilter;
        ofn.lpstrDefExt = FileChooserPlayListDefExt;
        break;
#endif // 0
    }

    return GetOpenFileName(&ofn);
}